<template>
    <view class="container" style="paddingBottom:1rpx;">
      <u-navbar
			leftIconSize="40rpx"
			leftIconColor="#333333"
			title="信用卡账单"
		>
		</u-navbar>
      <view class="section">
        <view class="section-title">{{ title}}</view>
        <view class="form-view">
          <u--form labelPosition="left" :model="form" :rules="rules" ref="uForm" label-width="auto"
            :labelStyle="{ color: '#333333', fontSize: '30rpx' }">
            <u-form-item label="信用卡" prop="creditCardName" required @click="handleCreditCard">
              <u--input v-model="form.creditCardName" disabled disabledColor="#ffffff" placeholder="请选择信用卡"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="账单日" prop="billDate" required @click="selectDate()">
              <u--input v-model="form.billDate" disabled disabledColor="#ffffff" placeholder="请选择账单日" inputAlign="right" border="none"></u--input>
						<u-icon slot="right" name="arrow-right"></u-icon>
            </u-form-item>
            <u-form-item label="账单金额" prop="billAmount" required >
              <u--input v-model="form.billAmount"  placeholder="请填写账单金额"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="账单状态" prop="billStateName" required @click="handleShowTeam">
              <u--input v-model="form.billStateName" disabled disabledColor="#ffffff" placeholder="请选择账单状态"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="备注" prop="remark" required labelPosition="top">
              <u--textarea v-model="form.remark" placeholder="请填写备注" border="none" autoHeight inputAlign="right" count
                maxlength="20000" style="padding:18rpx 0;"></u--textarea>
            </u-form-item>
          </u--form>
          <view class="form-btn">
            <u-button type="primary" text="提交" @click="submit"></u-button>
          </view>
        </view>
      </view>
      <u-toast ref="uToast"></u-toast>
      <u-picker itemHeight="88" :show="showTeam" :columns="billStateList" keyName="dictLabel" @cancel="handleCancel"
        @confirm="handleConfirm"></u-picker>
        <u-datetime-picker
			:show="datePickShow"
			mode="date"
      ref="createTimeRef" 
			@cancel="datePickShow=false"
			@confirm="datePickConfirm"
			itemHeight="88"
		></u-datetime-picker>
    <u-picker itemHeight="88" :show="showCreditCard" :columns="bankCardLendList" keyName="nameCodeAvailableLimit" @cancel="handleCreditCardCancel"
        @confirm="handleCreditCardConfirm"></u-picker>
    </view>
  </template>
  
  <script setup>
import {getCreditCardBill, addCreditCardBill, updateCreditCardBill } from '@/api/invest/creditCardBill'
  import { getDicts } from '@/api/system/dict/data.js'
  import { listAccounts } from '@/api/invest/accounts'
  const { proxy } = getCurrentInstance()
  import dayjs from 'dayjs'
  import {onLoad,onReady} from "@dcloudio/uni-app";
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed ,getCurrentInstance }from "vue";
const datePickShow = ref(false)
const showTeam = ref(false)
const showCreditCard = ref(false)
const title = ref("信用卡账单")
const bankCardLendList = ref([])
const billStateList = ref([])
const data = reactive({
  form: {
    id: null,
    name: null,
    billDate: null,
    creditCardId: null,
    billDatePeriod: null,
    billAmount: 0,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    billState: null,
    remark: null,
    delFlag: null
  },
  queryBankCardLendParams: {
    pageNum: 1,
    type: '2',
    state: '1',
    pageSize: 1000
  },
  rules: {
           creditCardName: [{ type: 'string', required: true, message: '信用卡不能为空', trigger: ['change', 'blur'] }],
          billDate: [{ type: 'string', required: true, message: '账单日不能为空', trigger: ['change', 'blur'] }],
          billStateName: [{ type: 'string', required: true, message: '账单状态不能为空', trigger: ['change', 'blur'] }],
          billAmount: [{ type: 'number', required: true, message: '账单金额不能为空', trigger: ['change', 'blur'] }],
  }
})
const { form, queryBankCardLendParams, rules} = toRefs(data)

onLoad((option) => {
       form.value.id = option.id
       if(form.value.id!=null){
        title.value="信用卡账单-修改"
       }else{
        title.value="信用卡账单-新增"
       }
      getDict()
  })
  onReady(() => {
    form.value.billDate = dayjs(new Date().getTime()).format("YYYY-MM-DD")
  })
  function  getDict() {
        // 账单状态
        getDicts('bill_state').then(res => {
        billStateList.value =[res.data] 
      })
      listAccounts(queryBankCardLendParams.value).then((response) => {
        bankCardLendList.value = [response.rows] 
      })
      if(form.value.id!=null){
        getCreditCardBill(form.value.id).then(res => {
          form.value = res.data
          form.value.creditCardName = res.data.bankNameCode
           // 类型
        getDicts('bill_state').then(result => {
          form.value.billStateName=dictStr(form.value.billState, result.data)
      })
          
        })
      }
  }
  function dictStr(val, arr) {
      let str = ''
      arr.map(item => {
        if (item.dictValue === val) {
          str = item.dictLabel
        }
      })
      return str
    }

  function handleShowTeam() {
        if (billStateList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '账单状态为空  ', type: 'warning'
          })
        } else {
          showTeam.value = true
        }
      }
      function   handleConfirm(e) {
        form.value.billStateName = e.value[0].dictLabel
        form.value.billState = e.value[0].dictValue
        showTeam.value = false
      }
      function handleCancel() {
       showTeam.value = false
      }
      function handleCreditCard() {
        if (bankCardLendList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '信用卡为空  ', type: 'warning'
          })
        } else {
          showCreditCard.value = true
        }
     }
  function   handleCreditCardConfirm(e) {
        form.value.creditCardName = e.value[0].nameCodeAvailableLimit
        form.value.creditCardId= e.value[0].id
        showCreditCard.value = false
  }
 function handleCreditCardCancel() {
       showCreditCard.value = false
  }

      function  selectDate() {
				datePickShow.value = true
        proxy.$refs['createTimeRef'].innerValue = new Date().getTime()
			}
			function datePickConfirm(e) {
				form.value.createTime = dayjs(e.value).format("YYYY-MM-DD")
				datePickShow.value = false
			}
      function submit() {
        proxy.$refs['uForm'].validate().then(() => {
          if (form.value.id != null) {
            updateCreditCardBill(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '修改成功', complete() {
                uni.navigateTo({ url: `/pages/work/bill/creditCardBill//list` })
              }
            })
          })
          }else {
            addCreditCardBill(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '新增成功', complete() {
                uni.navigateTo({ url: `/pages/work/bill/creditCardBill//list` })
              }
            })
          })
          }
        })
      }
  </script>
  
  <style lang="scss" scoped>
  .section {
    margin: 24rpx;
    padding: 16rpx 24rpx;
    background-color: #fff;
    border-radius: 8rpx;
  
    .section-title {
      width: 360rpx;
      color: #333333;
      line-height: 44rpx;
      font-size: 30rpx;
      border-left: 6rpx solid #2681FF;
      padding-left: 26rpx;
    }
  
    .form-view {
      padding: 20rpx 0rpx 0 10rpx;
  
      .form-btn {
        padding-top: 20rpx;
      }
    }
  }
  </style>